/**
  ******************************************************************************
  * @file           : main.c
  * @author         : SINOMCU-AE
  * @brief          : Main program body
  *    
  *          This file provides example code for PVD level6 and printf by uart:
  * uart send information of running count(redirect printf),defualt period 0.5s.
  * PDVO set LED blink fast period 0.25s,if not LED blink period 1s.
  * For details, see "readme.txt"    
  *         
  ******************************************************************************
   * @attention 
  *                           DISCLAIMER
  * The present firmware which is for guidance only aims at providing customers
  * with coding information regarding their products in order for them to save
  * time. As a result, SinoMCU shall not be held liable for any direct,indirect
  * or consequential damages with respect to any claims arising from the content 
  * of such firmware and/or the use made by customers of the coding information 
  * contained herein in connection with their products.
  *
  * <h2><center>&copy; Copyright (c) 2021 sinomcu All rights reserved.</center></h2>
  *
  ******************************************************************************
  */  
  
#include "system_define.h"

#define COUNT_PERIOD    500       // unit ms

FlagStatus PVD_IRQ_FLAG = RESET,READ_PVDO_FlAG = RESET;

/**
  * @brief  Main program
  * @param  None
  * @retval None
  */
int main(void) {
  uint32_t count=0;
  uint32_t LED_blink_Time = COUNT_PERIOD;
    
  //sysclk_init();                  // sysclk 48M,HSI/2 *12;if not call this function,default HSI 8M
  SystemCoreClockUpdate();        // get System Core Clock
    
  sys_tick_init();
  gpio_init();
  pvd_init();
  
#if(defined(EN_PRINT_UART) && EN_PRINT_UART)   
  MS32_RCC_SetUSARTClockSource(MS32_RCC_USART1_CLKSOURCE_HSI);       // uart clk HSI 8M  
  usart1_uart_init(115200);
#endif
  LED1_ON(); 
  READ_PVDO_FlAG = SET;                                              // for power on PVDO Get 
	
  printf("\r\n\r\n*****PVD level6 Example*****");
  printf("\r\n--Inf:System Core Clock %d Hz.",SystemCoreClock);
    
  Start_User_MS_SF_Timer(LED_blink_Time);
  while(1) {
    if(PVD_IRQ_FLAG == SET) {                                        // PVD interrupt
      PVD_IRQ_FLAG   = RESET; 
      READ_PVDO_FlAG = SET;                                          // going on read PVDO 
      printf("\r\n--Inf:!!!PVD detect!");
    }    
    
    if(Get_State_User_MS_SF_Timer() == SF_TIMER_OV) {
      Start_User_MS_SF_Timer(LED_blink_Time);                        // clear soft timer ov
      if( READ_PVDO_FlAG ==SET ) {                                   // had detect PVD
        if( MS32_PWR_IsActiveFlag_PVDO()) {                          // PVD status no change
          LED_blink_Time = COUNT_PERIOD >>2;                         // LED blink fast
          printf("\r\n--Inf:!!!Still in previous status!");
        }
        else {
          READ_PVDO_FlAG = RESET;                                    // PVD status change
          LED_blink_Time = COUNT_PERIOD;
        }
      }
      
      LED1_TOGGLE();
      count++;
      printf("\r\n--Inf: running count:%d",count);
    }
  }
}

/**
  * @brief  timer UIF interrupt callback function
  * @param  None
  * @retval None
  */
void PVD_Callback(void) {
  PVD_IRQ_FLAG = SET;
}

/**
  * @brief  SystemClock_Config HSI/2 to PLL*12 sysclk 48M
  * @param  None
  * @retval None
  */
void sysclk_init(void) {
  MS32_RCC_OscInitTypeDef osc_cfg;
  MS32_RCC_PllInitTypeDef pll_cfg;
  MS32_RCC_ClkInitTypeDef clk_cfg;

  // get and clear reset flag 
  MS32_RCC_GetResetFlag(ENABLE);
  
  // osc config 
  osc_cfg.HSIState = MS32_RCC_HSI_ON;
  osc_cfg.HSEState = MS32_RCC_HSE_OFF;
  osc_cfg.LSIState = MS32_RCC_LSI_OFF;
//  osc_cfg.LSEState = MS32_RCC_LSE_ON_DRV_H;
  MS32_RCC_OscConfig(&osc_cfg);
  
  // pll config 
  pll_cfg.PLLState  = MS32_RCC_PLL_ON;
  pll_cfg.PLLSource = MS32_RCC_PLL_SOURCE_HSI_DIV_2;       // HSI/2 4M
  pll_cfg.PLLMUL    = MS32_RCC_PLL_MUL12;
  pll_cfg.PREDIV    = MS32_RCC_PLL_PREDIV_DIV1;
  MS32_RCC_PllConfig(&pll_cfg);
  
  // sysclk config 
  clk_cfg.SYSCLKSource   = MS32_RCC_SYSCLK_SOURCE_PLL;
  clk_cfg.AHBCLKDivider  = MS32_RCC_SYSCLK_DIV1;
  clk_cfg.APB1CLKDivider = MS32_RCC_HCLK_DIV1;
  MS32_RCC_ClockConfig(&clk_cfg);
}

/******************************** END OF FILE *********************************/
